;
;
;
;      ͸                ͸  ͸  ͸  ͸
;       ͸                  ;         ;
;                                                 
;                                           ;    
;       ;                  ͸   ͸  ;   ͸
;        ͸ ͸              ͸             ͸  
;             ͸    ͸                                   
;                    ո                                    
;        ;     Ծ     ;             ;  
;      ;   ;    ;     ;    ;
;
;
; Bruno augier 07/1997


 DOSSEG
 MODEL LARGE
 STACK 400H
 .486
 


;
;  Cette macro doit tre plac en dbut de programme
;   elle effectue toute les initialisation ncessaire
;   HIMEM,clavier,DTA...
;

DEBUT_PROGRAMME MACRO
 INCLUDE D:\BSYS\FONCTION\FLAT.FNC          ; Fonction pour le mode flat
 INCLUDE D:\BSYS\FONCTION\FREE_OVE.FNC      ; Fonction qui libre la mmoire basse inutilis par le prog
 INCLUDE D:\BSYS\FONCTION\HIMEM.FNC         ; Fonctions pour grer le driver HIMEM.SYS
 INCLUDE D:\BSYS\FONCTION\CLAVIER.FNC       ; Fonctions pour grer le clavier
 INCLUDE D:\BSYS\FONCTION\MEMOIRE.FNC       ; Fonctions pour grer la mmoire basse et haute
 INCLUDE D:\BSYS\FONCTION\FICHIER.FNC       ; Fonctions pour grer l'acces au fichier
 INCLUDE D:\BSYS\FONCTION\IMAGE.FNC         ; Fonctions pour grer les image et la palette
 INCLUDE D:\BSYS\FONCTION\3D.FNC            ; Fonctions pour grer de la 3D
 INCLUDE D:\BSYS\FONCTION\GRAPH.FNC         ; Fonctions pour grer les graphique

 .DATA
  MODE_VIDEO_DEPART DB 0
  TEXTE_INIT_BSYS DB 'BSYS Bruno Augier 1997',13,10,'$'
  TEXTE_INIT_FLAT DB 'Model mmoire initialis',13,10,'$'
  TEXTE_INIT_OVERMEM DB 'Mmoire inutilis libre',13,10,'$'
  TEXTE_HIMEM_INSTALLE DB 'HIMEM.SYS dtect',10,13,'$'
  TEXTE_HIMEM_INITIALISATION DB 'Initialisation de HIMEM.SYS',10,13,'$'
  TEXTE_HIMEM_PAS_INSTALLE DB '!ERREUR! =>HIMEM.SYS non dtect',13,10,'$'
  TEXTE_CLAVIER_INITIALISE DB 'Clavier initialis',13,10,'$'
  TEXTE_CLAVIER_RESTAURE DB 'Clavier restaur',13,10,'$'
  TEXTE_HIMEM_ALLOCMEM DB 'Allocation de la mmoire tendue:   '  
  SUITE_HIMEM_ALLOCMEM DB '9Mb allou.',10,13,'$'  
  TEXTE_HIMEM_FREEMEM DB 'Mmoire tendue libre',10,13,'$'

  XMS_available DW 9000         ; Contient la taille maximale de mmoire suprieur libre en Ko
  XMS_handle DW 0               ; Contient le handle (HIMEM.SYS) de la mmoire haute allou
  XMS_ofs32 DD 0                ; Contient un offset 32 bit pour accder a la mmoire haute alloue

 .CODE
 START:
  MOV AX,@DATA                      ;
  MOV DS,AX                         ; Affiche un texte d'initialisation
  MOV DX,offset TEXTE_INIT_BSYS     ;
  MOV AH,09                         ;
  INT 21H                           ;

  FREE_OVER_MEM                     ; Libre la mmoire non utilis
  MOV DX,offset TEXTE_INIT_OVERMEM  ;  et affiche le texte correspondant
  MOV AH,09                         ;
  INT 21H                           ;

  FLAT_MODE                         ; Passe au mode flat
  MOV AX,@DATA                      ;  et affiche le texte correspondant
  MOV DS,AX
  MOV DX,offset TEXTE_INIT_FLAT
  MOV AH,09
  INT 21H
                                          
  TEST_HIMEM                              ;
  JE SHORT HIMEM_INSTALLE                 ;
   MOV DX,offset TEXTE_HIMEM_PAS_INSTALLE ;
   MOV AH,09                              ; Test si HIMEM est install
   INT 21H                                ;  si himem non install ferme le prog
  JMP FIN_PROG                            ;      

  HIMEM_INSTALLE:                         ; Affiche le texte pour dire que himem est install
   MOV DX,offset TEXTE_HIMEM_INSTALLE     ;
   MOV AH,09                              ;
   INT 21H

  GET_HIMEM_ADRESSE                         ;
  ACTIVE_A20                                ; Rcupre l'adresse du driver HIMEM
   MOV DX,offset TEXTE_HIMEM_INITIALISATION ;  active la ligne A20
   MOV AH,09                                ;
   INT 21H                                  ;


  PAS_ASSEZ_DE_MEMOIRE_XMS:                   ;
   DEC BYTE PTR DS:[SUITE_HIMEM_ALLOCMEM]     ; Rserve la mmoire tendue
   SUB XMS_available,1000                     ;  essaye d'abord d'allou le maximum demand
   GET_HIMEM_EMB XMS_available                ;  puis si impossible ressaye avec 1 Mo de moins
  CMP AX,1                                    ;
  JNE SHORT PAS_ASSEZ_DE_MEMOIRE_XMS          ;
  MOV XMS_handle,DX                           ;
  GET_HIMEM_EMBadresse XMS_handle             ;
  MOV WORD PTR [XMS_ofs32],BX                 ;
  MOV WORD PTR [XMS_ofs32+2],DX               ;
  MOV DX,offset TEXTE_HIMEM_ALLOCMEM          ; A partir d'ici XMS_available
  MOV AH,09                                   ;                XMS_handle et XMS_ofs32 
  INT 21H                                     ;                sont initialis

  FIXE_ADRESSE_DTA                            ; Fixe l'adresse de la DTA pour l'acc au fichier

  NEW_KEY                                     ; Installe le nouveau gestionnaire
   MOV DX,offset TEXTE_CLAVIER_INITIALISE     ;  de clavier
   MOV AH,09                                  ;
   INT 21H                                    ;

ENDM





;
; Cette macro doit etre plac en fin de programme
;  elle restore le clavier , libre la mmoire
;  tendue puis revient au DOS
;

FIN_PROGRAMME MACRO
 FIN_PROG:
  DEACTIVE_A20                             ; Dsactive la ligne d'adresse A20

  FREE_HIMEM_EMB XMS_handle                ; Libre la mmoire tendue
  MOV DX,offset TEXTE_HIMEM_FREEMEM        ;
  MOV AH,09                                ;
  INT 21H

  HOLD_KEY                                 ;
  MOV DX,offset TEXTE_CLAVIER_RESTAURE     ;  Restore le clavier
  MOV AH,09                                ;
  INT 21H                                  ;

  MOV AX,4C00H                             ;
  INT 21H                                  ; Retourne au dos
 END START                                 ;
ENDM





